﻿namespace Modbus.Messages
{
	internal sealed class ReadFifoQueueRequest : ModbusMessage
	{
		private ushort pointerAddress;
		
		public override void Read(ModbusReader reader)
		{
			base.Read(reader);

			this.pointerAddress = reader.ReadUInt16();
		}

		public override void Write(ModbusWriter writer)
		{
			base.Write(writer);

			writer.Write(this.pointerAddress);
		}

		public ushort PointerAddress
		{
			get { return this.pointerAddress; }
			set { this.pointerAddress = value; }
		}
	}
}
