﻿namespace Modbus.Messages
{
	internal sealed class WriteSingleRegisterMessage : ModbusMessage
	{
		private ushort registerAddress;
		private short  registerValue;

		public override void Read(ModbusReader reader)
		{
			base.Read(reader);

			this.registerAddress = reader.ReadUInt16();
			this.registerValue = reader.ReadInt16();
		}

		public override void Write(ModbusWriter writer)
		{
			base.Write(writer);

			writer.Write(this.registerAddress);
			writer.Write(this.registerValue);
		}

		public ushort RegisterAddress
		{
			get { return this.registerAddress; }
			set { this.registerAddress = value; }
		}

		public short RegisterValue
		{
			get { return this.registerValue; }
			set { this.registerValue = value; }
		}
	}
}
